package com.eactive.eai.batch.job.jobItem.bokjj;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.util.HashMap;
import java.util.Properties;

import com.eactive.eai.batch.common.FileUtil;
import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;
import com.eactive.eai.batch.running.BatchOpenFileManager;
import com.eactive.eai.common.exception.ExceptionUtil;


public class SEND_BOKJJ_0320 extends DefaultTelegram implements TelegramService {

	private FileInputStream fin;
    private int REAL_BYTE;         //실 data byte수
    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties telegramInfo;
    private byte[] fileData;

    /**
     * 생성자
     */
    public SEND_BOKJJ_0320() {
        //DATA송신
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = setBlockAndSeqNO();
            if (!result) {
                return false;
            }
            result = calculateSendLength();
            if (!result) return false;

            //전문송신 Byte 수 : 공통부 중 1 ~ 6번 길이(21)와 개별부 길이의 합 (전체 전문 길이 ? 5 )
            compileField(0, ""+SEND_LENGTH, this.al_FieldProps[0]);

            //업무구분코드 - FTP
            compileField(1, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[1]);

            //기관코드 - 『기본설계서(온라인)』 <별첨3> 참조
            compileField(2, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[2]);

            //전문종별코드.
            compileField(3, this.getFldTelegramType(), this.al_FieldProps[3]);

            //거래구분코드
            compileField(4, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[4]);

            //송수신 FLAG : 전문 발생 기관을 구분하여  아래의 값을 SET한다.
            //             C  : 한국은행 송신,  O  : 참가기관 송신
            compileField(5, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[5]);

            //응답코드
            compileField(6, this.getResolveResponseCode(), this.al_FieldProps[6]);
            // 여기 까지 공통부

            //송수신 업무 구분코드.
            //“S”: 파일 송신업무 관련 전문 (한국은행 → 은행)
            //“R”: 파일 수신업무 관련 전문 (은행 → 한국은행)
            compileField(7, getFldTrClass() , this.al_FieldProps[7]);

            //Block-NO
            if ( !this.getFldOpCode().equals("999") ){
                compileField(8, ""+this.batchDoc.getBatchMsg().getBody().getBlockNum() , this.al_FieldProps[8]);
            }else{
                compileField(8, "9999", this.al_FieldProps[8]);
            }

            //Sequence-NO
            if ( !this.getFldOpCode().equals("999") ){
                compileField(9, ""+this.batchDoc.getBatchMsg().getBody().getSeqNum() , this.al_FieldProps[9]);
            }else{
                compileField(9, "999", this.al_FieldProps[9]);
            }

            //Record 수
            int recCnt = this.REAL_BYTE / batchDoc.getBatchMsg().getHeader().getRecLen();
            compileField(10, "" + recCnt, this.al_FieldProps[10]);

            int block_num = this.batchDoc.getBatchMsg().getBody().getBlockNum();
            if ( block_num > 0 && block_num < 9999) {
                batchDoc.getBatchMsg().getBody().setRecCnt( batchDoc.getBatchMsg().getBody().getRecCnt() + recCnt );
            }

            //<< 전문 완성

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < REAL_BYTE) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }

            ByteArrayInputStream bin = new ByteArrayInputStream(fileData);
            bin.read(data, 0, REAL_BYTE);

            // 20060419 add by khs for 전송상태 확인
            long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize() + REAL_BYTE;
            batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);

            return REAL_BYTE;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    public boolean doPostExecute() {
        try {
            Thread.sleep(TelegramKeys.BOKJJ_DELAY_MILISEC);
            if (!super.doPostExecute()) return false;

            if (this.getFldOpCode().equals("999") ){
                if (fin != null ) {
                    fin.close();
                    BatchOpenFileManager.getInstance().removeFile(batchDoc.getBatchMsg().getHeader().getUUID() );
                }
            }

            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<7; i++) { //신한은망 전문의 헤더는 응답코드까지 임.
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=7; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * 비정형 필드에 대한 송신 길이를 계산해서 리턴해준다.
     *
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     *
     * 비정형 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
               return REAL_BYTE;
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                logger.debug("{} getCalculatedLength> parameter is not FIELD_NO_LENGTH", logHeader);
                return -1;
            }
        }catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    private boolean createFile ()
    {
        try {
            fin = BatchOpenFileManager.getInstance().getFile(batchDoc.getBatchMsg().getHeader().getUUID() );

            if ( fin == null) {
                String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
                String fileNm  = batchDoc.getBatchMsg().getHeader().getRenamedFileName();

                if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                    fileDir = fileDir + File.separator;
                }

                String fileName = fileDir + fileNm;

                File file = new File(fileName);
                if (!file.exists()) // 파일이 없으면 리턴 False
                {
                    logger.debug("{} the File["+fileDir+"/"+file.getName()+"] does not exist!!!", logHeader);
                    String[] msgArgs = new String[2];
                    msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                    msgArgs[1] = fileName;
                    String errCode = "BECEAIFJI022";
                    String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                    this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                    return false;
                }

                fin = new FileInputStream(file);
                BatchOpenFileManager.getInstance().addFile(batchDoc.getBatchMsg().getHeader().getUUID() , fileName, fin);
            }

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    private boolean setBlockAndSeqNO ()
    {
        try {
            if (!createFile()) {
                logger.error("{}  file open failed", logHeader);
                return false;
            }

            int BLOCK_NO      = 0;
            int SEQUENCE_NO   = 0;
            int sequence_size = batchDoc.getBatchMsg().getHeader().getSequenceSize();
            int block_size    = batchDoc.getBatchMsg().getHeader().getBlockSize();
            int block_no      = batchDoc.getBatchMsg().getBody().getBlockNum();
            int seq_no        = batchDoc.getBatchMsg().getBody().getSeqNum();
            int recLen        = batchDoc.getBatchMsg().getHeader().getRecLen();

            this.setConditionTxt("");

            // 파일에서 읽은 DATA를 추후 결번 재전송을 위해 메모리에 저장해 둔다. 2008.06.19 - 정동한
            JobProcessData job = JobProcessData.getInstance();
            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            HashMap<String, Object> hm = (HashMap<String, Object>)job.getBatchStageData(uuid);

            @SuppressWarnings("unchecked")
            HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>) hm.get(JobProcessData.PROCDATA_BLOCKDATA);
            if (block_data == null) {
                block_data = new HashMap<Integer, byte[]>();
            }

            if (this.getFldOpCode().equals("000")) {
                fileData = new byte[recLen];
                byte[] fileLine = FileUtil.readLine(fin);
                System.arraycopy(fileLine, 0, fileData, 0, Math.min(fileLine.length, fileData.length));
                batchDoc.getBatchMsg().setFileHeader(new String(fileLine));
                batchDoc.getBatchMsg().getBody().setCurFileSize(0);
            }
            else if (this.getFldOpCode().equals("999")) {
                BLOCK_NO = 9999;
                SEQUENCE_NO = 999;
                fileData = new byte[recLen];
                byte[] fileLine = FileUtil.readLine(fin);
                System.arraycopy(fileLine, 0, fileData, 0, Math.min(fileLine.length, fileData.length));
                batchDoc.getBatchMsg().setFileTrailer(new String(fileLine));

                // 전송내역 추가
                String sendSum = batchDoc.getBatchMsg().getBody().getSendSummary();
                if (sendSum == null ){
                    sendSum = "01"
                              + batchDoc.getBatchMsg().getHeader().getBizCode().substring(4,6)
                              + makeZero( "" + ( batchDoc.getBatchMsg().getHeader().getTotRecCnt() - 2 ), 7 ) ;
                } else {
                    int sendedFileCnt = Integer.parseInt(sendSum.substring(0,2));
                    sendSum = makeZero( "" + ( sendedFileCnt + 1), 2 )
                              + sendSum.substring(2, 2 + 9*sendedFileCnt)
                              + batchDoc.getBatchMsg().getHeader().getBizCode().substring(4,6)
                              + makeZero( "" + ( batchDoc.getBatchMsg().getHeader().getTotRecCnt() - 2 ), 7 ) ;
                }
                batchDoc.getBatchMsg().getBody().setSendSummary(sendSum);

            } else {
                if (block_no == 0 && seq_no == 0){
                    block_no = 1;
                    seq_no = 1;
                    BLOCK_NO = 1;
                    SEQUENCE_NO = 1;
                    this.setConditionTxt("");
                } else {
                    if (seq_no == block_size) { //한 블럭 송신 후 결번확인(0300) 이후 데이터 전송
                        BLOCK_NO = block_no+1;
                        SEQUENCE_NO = 1;
                        setConditionTxt("");

                    } else if (seq_no >= block_size-1) {    //블럭 크기에 도달하면 BLOCKEND 하여 다음 0620전문으로 넘어가게 함
                        BLOCK_NO = block_no;
                        SEQUENCE_NO = seq_no+1;
                        this.setConditionTxt(TelegramKeys.BLOCKEND);
                    } else {            //한 블럭내에 데이터 전송 반복이면
                        BLOCK_NO = block_no;
                        SEQUENCE_NO = seq_no+1;
                        this.setConditionTxt("");
                    }
                }

                // 한번에 블러킹 할 건수
                int seqCnt = ( sequence_size / recLen );
                // 남은 바이트 수
                long remainSize = batchDoc.getBatchMsg().getHeader().getFileSize() - batchDoc.getBatchMsg().getBody().getCurFileSize();
                // 남은 건수
                long remainCnt = remainSize / recLen;

                if ( seqCnt < remainCnt - 1){
                    REAL_BYTE = seqCnt * recLen;
                }else{
                    REAL_BYTE = (int)(remainCnt - 1) * recLen;
                }
                int readCnt = REAL_BYTE / recLen;
                if ( remainCnt - readCnt <= 1 ) {
                    this.setConditionTxt(TelegramKeys.EOF);
                }

                fileData = new byte[REAL_BYTE];
                for ( int inx = 0 ; inx < readCnt ; inx++){
                    byte[] fileLine = FileUtil.readLine(fin);
                    System.arraycopy( fileLine, 0, fileData, inx * batchDoc.getBatchMsg().getHeader().getRecLen(), batchDoc.getBatchMsg().getHeader().getRecLen());
                }

                block_data.put( new Integer(SEQUENCE_NO-1), fileData);
                hm.put(JobProcessData.PROCDATA_BLOCKDATA, block_data);

                // 이후 0600 전문 송신시에는 최종 block, seq를 보내 줘야 하기 때문에 헤더트레일러인 경우는 다음을 셋하지 않는다.
                this.batchDoc.getBatchMsg().getBody().setBlockNum(BLOCK_NO);
                this.batchDoc.getBatchMsg().getBody().setSeqNum(SEQUENCE_NO);
            }

            REAL_BYTE = fileData.length;

            return true;
        } catch (Exception e ) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI029";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size()-1; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += REAL_BYTE;
            REAL_SEND_LENGTH = SEND_LENGTH;
            for (int i=0; i < 2 ; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                REAL_SEND_LENGTH += aField.length;
            }
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }


    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(7);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(6);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }

}
